//! @file onedim.h

/*!
 * @defgroup onedim One-Dimensional Reacting Flows
 *
 * These classes comprise Cantera's ability to solve steady-state one-
 * dimensional reacting flow problems, such as laminar flames, opposed flow
 * diffusion flames, and stagnation flow chemical vapor deposition.
 */

#ifndef CT_INCL_ONEDIM_H
#define CT_INCL_ONEDIM_H

#include "oneD/Sim1D.h"
#include "oneD/OneDim.h"
#include "oneD/Domain1D.h"
#include "oneD/Inlet1D.h"
#include "oneD/MultiNewton.h"
#include "oneD/MultiJac.h"
#include "oneD/StFlow.h"
#endif

